=== modified file 'init/parse_job.c'
--- init/parse_job.c	2009-01-29 04:23:21 +0000
+++ init/parse_job.c	2009-02-23 08:09:53 +0000
@@ -47,213 +107,2462 @@
 #include "parse_job.h"
 #include "errors.h"
 
-
-/* Prototypes for static functions */
-static int            parse_exec        (Process *process,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int            parse_script      (Process *process,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int            parse_process     (JobClass *class, ProcessType process,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static EventOperator *parse_on          (JobClass *class,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result, malloc));
-static int            parse_on_operator (JobClass *class,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno,
-					 NihList *stack, EventOperator **root)
-	__attribute__ ((warn_unused_result));
-static int            parse_on_paren    (JobClass *class,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno,
-					 NihList *stack, EventOperator **root,
-					 size_t *paren)
-	__attribute__ ((warn_unused_result));
-static int            parse_on_operand  (JobClass *class,
-					 NihConfigStanza *stanza,
-					 const char *file, size_t len,
-					 size_t *pos, size_t *lineno,
-					 NihList *stack, EventOperator **root)
-	__attribute__ ((warn_unused_result));
-static int            parse_on_collect  (JobClass *class,
-					 NihList *stack, EventOperator **root)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_instance    (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_description (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_author      (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_version     (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_env         (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_export      (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_start       (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_stop        (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_emits       (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_exec        (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_script      (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_pre_start   (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_post_start  (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_pre_stop    (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_post_stop   (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_expect      (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_task        (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_kill        (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_respawn     (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_normal      (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_session     (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_console     (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-static int stanza_umask       (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_nice        (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_oom         (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_limit       (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_chroot      (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-static int stanza_chdir       (JobClass *class, NihConfigStanza *stanza,
-			       const char *file, size_t len,
-			       size_t *pos, size_t *lineno)
-	__attribute__ ((warn_unused_result));
-
-
-/**
- * stanzas:
- *
- * This is the table of known job definition stanzas and the functions
- * that handle parsing them.
- **/
-static NihConfigStanza stanzas[] = {
-	{ "instance",    (NihConfigHandler)stanza_instance    },
-	{ "description", (NihConfigHandler)stanza_description },
-	{ "author",      (NihConfigHandler)stanza_author      },
-	{ "version",     (NihConfigHandler)stanza_version     },
-	{ "env",         (NihConfigHandler)stanza_env         },
-	{ "export",      (NihConfigHandler)stanza_export      },
-	{ "start",       (NihConfigHandler)stanza_start       },
-	{ "stop",        (NihConfigHandler)stanza_stop        },
-	{ "emits",       (NihConfigHandler)stanza_emits       },
-	{ "exec",        (NihConfigHandler)stanza_exec        },
-	{ "script",      (NihConfigHandler)stanza_script      },
-	{ "pre-start",   (NihConfigHandler)stanza_pre_start   },
-	{ "post-start",  (NihConfigHandler)stanza_post_start  },
-	{ "pre-stop",    (NihConfigHandler)stanza_pre_stop    },
-	{ "post-stop",   (NihConfigHandler)stanza_post_stop   },
-	{ "expect",      (NihConfigHandler)stanza_expect      },
-	{ "task",        (NihConfigHandler)stanza_task        },
-	{ "kill",        (NihConfigHandler)stanza_kill        },
-	{ "respawn",     (NihConfigHandler)stanza_respawn     },
-	{ "normal",      (NihConfigHandler)stanza_normal      },
-	{ "session",     (NihConfigHandler)stanza_session     },
-	{ "console",     (NihConfigHandler)stanza_console     },
-	{ "umask",       (NihConfigHandler)stanza_umask       },
-	{ "nice",        (NihConfigHandler)stanza_nice        },
-	{ "oom",         (NihConfigHandler)stanza_oom         },
-	{ "limit",       (NihConfigHandler)stanza_limit       },
-	{ "chroot",      (NihConfigHandler)stanza_chroot      },
-	{ "chdir",       (NihConfigHandler)stanza_chdir       },
-
-	NIH_CONFIG_LAST
-};
-
+#define YY_NIH_SYSERR(_e) ({ 			\
+	typeof (_e) ret;			\
+	if (! (ret = (_e))) {			\
+		nih_error_raise_system ();	\
+		YYABORT;			\
+	}					\
+	ret;					\
+})
+
+/* The error token */
+#define ERROR 256
+
+/* Holds a value that may be either int or string */
+typedef struct multi {
+	unsigned long  num;
+	char          *string;
+} Multi;
+
+/* YY Control stuff */
+#define YYDEBUG 1
+#define YYPRINT
+
+void print_tree (EventOperator *op)
+{
+	if (op->type == EVENT_MATCH) {
+		printf ("(match %s)", op->name);
+	} else {
+		printf ("(%s ", op->type == EVENT_OR ? "or" : "and");
+		print_tree ((EventOperator *)op->node.left);
+		printf (" ");
+		print_tree ((EventOperator *)op->node.right);
+		printf (")");
+	}
+
+	if (!op->node.parent)
+		printf ("\n");
+}
+
+
+
+/* Enabling traces.  */
+#ifndef YYDEBUG
+# define YYDEBUG 0
+#endif
+
+/* Enabling verbose error messages.  */
+#ifdef YYERROR_VERBOSE
+# undef YYERROR_VERBOSE
+# define YYERROR_VERBOSE 1
+#else
+# define YYERROR_VERBOSE 0
+#endif
+
+/* Enabling the token table.  */
+#ifndef YYTOKEN_TABLE
+# define YYTOKEN_TABLE 1
+#endif
+
+#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
+typedef union YYSTYPE
+#line 95 "parse_job.y"
+{
+	char          *string;	/* Tokens and scripts*/
+	EventOperator *oper;    /* Event Operator segments */
+	Process       *proc;    /* Processes */
+	Multi          multi;   /* Number/string dealies */
+	unsigned long  num;     /* Numbers */
+}
+/* Line 187 of yacc.c.  */
+#line 180 "parse_job.c"
+	YYSTYPE;
+# define yystype YYSTYPE /* obsolescent; will be withdrawn */
+# define YYSTYPE_IS_DECLARED 1
+# define YYSTYPE_IS_TRIVIAL 1
+#endif
+
+
+
+/* Copy the second part of user declarations.  */
+#line 103 "parse_job.y"
+
+static int   categorize_token        (YYSTYPE *lp, const char **file, char *tok, size_t *lineno);
+static int   categorize_string_token (YYSTYPE *lp, const char **file, char *tok, size_t *lineno);
+static char *pull_token              (const char **file, void *alloc_parent, size_t *lineno);
+static int   yylex                   (YYSTYPE *lp, const char **file, void *alloc_parent, size_t *lineno);
+static int   tok_lookup              (char *tok);
+static void  yyerror                 (JobClass *class, const char **file, void *parent, size_t *lineno, const char *msg);
+
+
+/* Line 216 of yacc.c.  */
+#line 201 "parse_job.c"
+
+#ifdef short
+# undef short
+#endif
+
+#ifdef YYTYPE_UINT8
+typedef YYTYPE_UINT8 yytype_uint8;
+#else
+typedef unsigned char yytype_uint8;
+#endif
+
+#ifdef YYTYPE_INT8
+typedef YYTYPE_INT8 yytype_int8;
+#elif (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+typedef signed char yytype_int8;
+#else
+typedef short int yytype_int8;
+#endif
+
+#ifdef YYTYPE_UINT16
+typedef YYTYPE_UINT16 yytype_uint16;
+#else
+typedef unsigned short int yytype_uint16;
+#endif
+
+#ifdef YYTYPE_INT16
+typedef YYTYPE_INT16 yytype_int16;
+#else
+typedef short int yytype_int16;
+#endif
+
+#ifndef YYSIZE_T
+# ifdef __SIZE_TYPE__
+#  define YYSIZE_T __SIZE_TYPE__
+# elif defined size_t
+#  define YYSIZE_T size_t
+# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
+#  define YYSIZE_T size_t
+# else
+#  define YYSIZE_T unsigned int
+# endif
+#endif
+
+#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)
+
+#ifndef YY_
+# if YYENABLE_NLS
+#  if ENABLE_NLS
+#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
+#   define YY_(msgid) dgettext ("bison-runtime", msgid)
+#  endif
+# endif
+# ifndef YY_
+#  define YY_(msgid) msgid
+# endif
+#endif
+
+/* Suppress unused-variable warnings by "using" E.  */
+#if ! defined lint || defined __GNUC__
+# define YYUSE(e) ((void) (e))
+#else
+# define YYUSE(e) /* empty */
+#endif
+
+/* Identity function, used to suppress warnings about constant conditions.  */
+#ifndef lint
+# define YYID(n) (n)
+#else
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static int
+YYID (int i)
+#else
+static int
+YYID (i)
+    int i;
+#endif
+{
+  return i;
+}
+#endif
+
+#if ! defined yyoverflow || YYERROR_VERBOSE
+
+/* The parser invokes alloca or malloc; define the necessary symbols.  */
+
+# ifdef YYSTACK_USE_ALLOCA
+#  if YYSTACK_USE_ALLOCA
+#   ifdef __GNUC__
+#    define YYSTACK_ALLOC __builtin_alloca
+#   elif defined __BUILTIN_VA_ARG_INCR
+#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
+#   elif defined _AIX
+#    define YYSTACK_ALLOC __alloca
+#   elif defined _MSC_VER
+#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
+#    define alloca _alloca
+#   else
+#    define YYSTACK_ALLOC alloca
+#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
+#     ifndef _STDLIB_H
+#      define _STDLIB_H 1
+#     endif
+#    endif
+#   endif
+#  endif
+# endif
+
+# ifdef YYSTACK_ALLOC
+   /* Pacify GCC's `empty if-body' warning.  */
+#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
+#  ifndef YYSTACK_ALLOC_MAXIMUM
+    /* The OS might guarantee only one guard page at the bottom of the stack,
+       and a page size can be as small as 4096 bytes.  So we cannot safely
+       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
+       to allow for a few compiler-allocated temporary stack slots.  */
+#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
+#  endif
+# else
+#  define YYSTACK_ALLOC YYMALLOC
+#  define YYSTACK_FREE YYFREE
+#  ifndef YYSTACK_ALLOC_MAXIMUM
+#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
+#  endif
+#  if (defined __cplusplus && ! defined _STDLIB_H \
+       && ! ((defined YYMALLOC || defined malloc) \
+	     && (defined YYFREE || defined free)))
+#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
+#   ifndef _STDLIB_H
+#    define _STDLIB_H 1
+#   endif
+#  endif
+#  ifndef YYMALLOC
+#   define YYMALLOC malloc
+#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
+#   endif
+#  endif
+#  ifndef YYFREE
+#   define YYFREE free
+#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+void free (void *); /* INFRINGES ON USER NAME SPACE */
+#   endif
+#  endif
+# endif
+#endif /* ! defined yyoverflow || YYERROR_VERBOSE */
+
+
+#if (! defined yyoverflow \
+     && (! defined __cplusplus \
+	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))
+
+/* A type that is properly aligned for any stack member.  */
+union yyalloc
+{
+  yytype_int16 yyss;
+  YYSTYPE yyvs;
+  };
+
+/* The size of the maximum gap between one aligned stack and the next.  */
+# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)
+
+/* The size of an array large to enough to hold all stacks, each with
+   N elements.  */
+# define YYSTACK_BYTES(N) \
+     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
+      + YYSTACK_GAP_MAXIMUM)
+
+/* Copy COUNT objects from FROM to TO.  The source and destination do
+   not overlap.  */
+# ifndef YYCOPY
+#  if defined __GNUC__ && 1 < __GNUC__
+#   define YYCOPY(To, From, Count) \
+      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
+#  else
+#   define YYCOPY(To, From, Count)		\
+      do					\
+	{					\
+	  YYSIZE_T yyi;				\
+	  for (yyi = 0; yyi < (Count); yyi++)	\
+	    (To)[yyi] = (From)[yyi];		\
+	}					\
+      while (YYID (0))
+#  endif
+# endif
+
+/* Relocate STACK from its old location to the new one.  The
+   local variables YYSIZE and YYSTACKSIZE give the old and new number of
+   elements in the stack, and YYPTR gives the new location of the
+   stack.  Advance YYPTR to a properly aligned location for the next
+   stack.  */
+# define YYSTACK_RELOCATE(Stack)					\
+    do									\
+      {									\
+	YYSIZE_T yynewbytes;						\
+	YYCOPY (&yyptr->Stack, Stack, yysize);				\
+	Stack = &yyptr->Stack;						\
+	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
+	yyptr += yynewbytes / sizeof (*yyptr);				\
+      }									\
+    while (YYID (0))
+
+#endif
+
+/* YYFINAL -- State number of the termination state.  */
+#define YYFINAL  106
+/* YYLAST -- Last index in YYTABLE.  */
+#define YYLAST   138
+
+/* YYNTOKENS -- Number of terminals.  */
+#define YYNTOKENS  64
+/* YYNNTS -- Number of nonterminals.  */
+#define YYNNTS  50
+/* YYNRULES -- Number of rules.  */
+#define YYNRULES  118
+/* YYNRULES -- Number of states.  */
+#define YYNSTATES  157
+
+/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
+#define YYUNDEFTOK  2
+#define YYMAXUTOK   315
+
+#define YYTRANSLATE(YYX)						\
+  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)
+
+/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
+static const yytype_uint8 yytranslate[] =
+{
+       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+      11,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+      21,    22,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
+       5,     6,     7,     8,     9,    10,    12,    13,    14,    15,
+      16,    17,    18,    19,    20,    23,    24,    25,    26,    27,
+      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
+      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
+      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
+      58,    59,    60,    61,    62,    63
+};
+
+#if YYDEBUG
+/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
+   YYRHS.  */
+static const yytype_uint16 yyprhs[] =
+{
+       0,     0,     3,     4,     6,     9,    13,    15,    17,    19,
+      21,    23,    25,    27,    29,    30,    32,    34,    36,    38,
+      40,    42,    44,    46,    48,    50,    52,    54,    56,    58,
+      60,    62,    64,    66,    68,    70,    72,    74,    76,    78,
+      81,    84,    87,    90,    93,    97,    98,   101,   104,   107,
+     110,   112,   116,   120,   124,   126,   132,   138,   144,   146,
+     149,   153,   154,   157,   159,   161,   163,   165,   166,   168,
+     170,   172,   174,   177,   180,   182,   184,   186,   188,   190,
+     194,   197,   198,   201,   205,   210,   211,   214,   216,   218,
+     220,   223,   226,   228,   230,   232,   235,   238,   241,   244,
+     247,   249,   251,   255,   257,   259,   261,   263,   265,   267,
+     269,   271,   273,   275,   277,   279,   281,   283,   286
+};
+
+/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
+static const yytype_int8 yyrhs[] =
+{
+      65,     0,    -1,    -1,    71,    -1,    65,    11,    -1,    65,
+      11,    71,    -1,     6,    -1,     3,    -1,     5,    -1,     4,
+      -1,     3,    -1,     4,    -1,     5,    -1,     4,    -1,    -1,
+      11,    -1,    72,    -1,    91,    -1,    73,    -1,    74,    -1,
+      75,    -1,    76,    -1,    77,    -1,    79,    -1,    80,    -1,
+      85,    -1,    92,    -1,    94,    -1,    95,    -1,    96,    -1,
+      98,    -1,   102,    -1,   103,    -1,   105,    -1,   106,    -1,
+     107,    -1,   108,    -1,   112,    -1,   113,    -1,    12,    66,
+      -1,    13,    66,    -1,    14,    66,    -1,    15,    66,    -1,
+      16,    66,    -1,    17,    78,    66,    -1,    -1,    78,    66,
+      -1,    18,    81,    -1,    19,    81,    -1,    20,    82,    -1,
+      84,    -1,    21,    83,    22,    -1,    82,    10,    82,    -1,
+      82,     9,    82,    -1,    82,    -1,    21,    70,    83,    70,
+      22,    -1,    82,    70,    10,    70,    82,    -1,    82,    70,
+       9,    70,    82,    -1,    66,    -1,    84,    66,    -1,    23,
+      86,    66,    -1,    -1,    86,    66,    -1,     7,    -1,     8,
+      -1,    87,    -1,    88,    -1,    -1,    24,    -1,    25,    -1,
+      26,    -1,    27,    -1,    90,    89,    -1,    28,    93,    -1,
+      19,    -1,    29,    -1,    30,    -1,    31,    -1,    32,    -1,
+      33,    34,    67,    -1,    35,    97,    -1,    -1,    36,    37,
+      -1,    36,    67,    67,    -1,    38,    39,   100,    99,    -1,
+      -1,   100,    99,    -1,   101,    -1,    67,    -1,    68,    -1,
+      40,    41,    -1,    42,   104,    -1,    31,    -1,    43,    -1,
+      44,    -1,    45,    69,    -1,    46,    67,    -1,    47,    67,
+      -1,    47,    48,    -1,    36,   110,    -1,    67,    -1,    37,
+      -1,   111,   109,   109,    -1,    49,    -1,    50,    -1,    51,
+      -1,    52,    -1,    53,    -1,    54,    -1,    55,    -1,    46,
+      -1,    56,    -1,    57,    -1,    58,    -1,    59,    -1,    60,
+      -1,    61,    -1,    62,    66,    -1,    63,    66,    -1
+};
+
+/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
+static const yytype_uint16 yyrline[] =
+{
+       0,   145,   145,   146,   147,   148,   150,   151,   152,   153,
+     155,   156,   158,   159,   161,   162,   164,   165,   166,   167,
+     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
+     178,   179,   180,   181,   182,   183,   184,   185,   186,   188,
+     191,   194,   197,   200,   203,   205,   206,   209,   210,   211,
+     212,   213,   214,   224,   234,   235,   236,   246,   256,   257,
+     263,   265,   266,   269,   274,   279,   280,   281,   282,   283,
+     284,   285,   286,   293,   294,   295,   296,   297,   299,   301,
+     311,   312,   313,   317,   327,   328,   329,   330,   339,   340,
+     342,   344,   345,   346,   347,   349,   351,   353,   354,   356,
+     357,   358,   359,   364,   365,   366,   367,   368,   369,   370,
+     371,   372,   373,   374,   375,   376,   377,   379,   382
+};
+#endif
+
+#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
+/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
+   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
+static const char *const yytname[] =
+{
+  "$end", "error", "$undefined", "MAYBE_NUMBER", "MAYBE_UMASK",
+  "MAYBE_SIGNAL", "KNOWN_STRING", "EXEC_LINE", "SCRIPT_BODY", "\"and\"",
+  "\"or\"", "'\\n'", "\"instance\"", "\"description\"", "\"author\"",
+  "\"version\"", "\"env\"", "\"export\"", "\"start\"", "\"stop\"",
+  "\"on\"", "'('", "')'", "\"emits\"", "\"pre-start\"", "\"pre-stop\"",
+  "\"post-start\"", "\"post-stop\"", "\"expect\"", "\"daemon\"",
+  "\"fork\"", "\"none\"", "\"task\"", "\"kill\"", "\"timeout\"",
+  "\"respawn\"", "\"limit\"", "\"unlimited\"", "\"normal\"", "\"exit\"",
+  "\"session\"", "\"leader\"", "\"console\"", "\"output\"", "\"owner\"",
+  "\"umask\"", "\"nice\"", "\"oom-adj\"", "\"never\"", "\"as\"",
+  "\"core\"", "\"cpu\"", "\"data\"", "\"fsize\"", "\"memlock\"",
+  "\"msgqueue\"", "\"nofile\"", "\"nproc\"", "\"rss\"", "\"rtprio\"",
+  "\"sigpending\"", "\"stack\"", "\"chroot\"", "\"chdir\"", "$accept",
+  "input", "STR", "NUM", "SIGNAL", "UMASK", "BSP", "stanza",
+  "instance_stanza", "description_stanza", "author_stanza",
+  "version_stanza", "env_stanza", "export_stanza", "export_list",
+  "start_stanza", "stop_stanza", "on_list", "event_operator",
+  "broken_event_operator", "event_spec", "emits_stanza", "emits_list",
+  "exec_line", "script_body", "process", "process_type", "script_stanza",
+  "expect_stanza", "expect_type", "task_stanza", "kill_stanza",
+  "respawn_stanza", "respawn_info", "normal_stanza", "exit_arg_list",
+  "exit_arg", "exit_status", "session_stanza", "console_stanza",
+  "console_type", "umask_stanza", "nice_stanza", "oom_stanza",
+  "limit_stanza", "limit_value", "limit_spec", "limit_name",
+  "chroot_stanza", "chdir_stanza", 0
+};
+#endif
+
+# ifdef YYPRINT
+/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
+   token YYLEX-NUM.  */
+static const yytype_uint16 yytoknum[] =
+{
+       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
+     265,    10,   266,   267,   268,   269,   270,   271,   272,   273,
+     274,    40,    41,   275,   276,   277,   278,   279,   280,   281,
+     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
+     292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
+     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
+     312,   313,   314,   315
+};
+# endif
+
+/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
+static const yytype_uint8 yyr1[] =
+{
+       0,    64,    65,    65,    65,    65,    66,    66,    66,    66,
+      67,    67,    68,    69,    70,    70,    71,    71,    71,    71,
+      71,    71,    71,    71,    71,    71,    71,    71,    71,    71,
+      71,    71,    71,    71,    71,    71,    71,    71,    71,    72,
+      73,    74,    75,    76,    77,    78,    78,    79,    80,    81,
+      82,    82,    82,    82,    83,    83,    83,    83,    84,    84,
+      85,    86,    86,    87,    88,    89,    89,    90,    90,    90,
+      90,    90,    91,    92,    93,    93,    93,    93,    94,    95,
+      96,    97,    97,    97,    98,    99,    99,   100,   101,   101,
+     102,   103,   104,   104,   104,   105,   106,   107,   107,   108,
+     109,   109,   110,   111,   111,   111,   111,   111,   111,   111,
+     111,   111,   111,   111,   111,   111,   111,   112,   113
+};
+
+/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
+static const yytype_uint8 yyr2[] =
+{
+       0,     2,     0,     1,     2,     3,     1,     1,     1,     1,
+       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
+       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
+       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
+       2,     2,     2,     2,     3,     0,     2,     2,     2,     2,
+       1,     3,     3,     3,     1,     5,     5,     5,     1,     2,
+       3,     0,     2,     1,     1,     1,     1,     0,     1,     1,
+       1,     1,     2,     2,     1,     1,     1,     1,     1,     3,
+       2,     0,     2,     3,     4,     0,     2,     1,     1,     1,
+       2,     2,     1,     1,     1,     2,     2,     2,     2,     2,
+       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
+       1,     1,     1,     1,     1,     1,     1,     2,     2
+};
+
+/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
+   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
+   means the default is an error.  */
+static const yytype_uint8 yydefact[] =
+{
+       2,     0,     0,     0,     0,     0,    45,     0,     0,    61,
+      68,    69,    70,    71,     0,    78,     0,    81,     0,     0,
+       0,     0,     0,     0,     0,     0,     0,     0,     3,    16,
+      18,    19,    20,    21,    22,    23,    24,    25,     0,    17,
+      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
+      36,    37,    38,     7,     9,     8,     6,    39,    40,    41,
+      42,    43,     0,     0,    47,    48,     0,    74,    75,    76,
+      77,    73,     0,     0,    80,   110,   103,   104,   105,   106,
+     107,   108,   109,   111,   112,   113,   114,   115,   116,    99,
+       0,     0,    90,    92,    93,    94,    91,    13,    95,    10,
+      11,    96,    98,    97,   117,   118,     1,     4,    63,    64,
+      65,    66,    72,    46,     0,    58,    49,    50,    62,    79,
+      82,     0,   101,   100,     0,    12,    88,    89,    85,    87,
+       5,     0,    54,     0,     0,     0,    59,    83,   102,    84,
+      85,    15,     0,     0,    51,    53,    52,    86,    14,    14,
+      14,     0,     0,     0,    55,    57,    56
+};
+
+/* YYDEFGOTO[NTERM-NUM].  */
+static const yytype_int16 yydefgoto[] =
+{
+      -1,    27,   115,   126,   127,    98,   142,    28,    29,    30,
+      31,    32,    33,    34,    62,    35,    36,    64,   132,   133,
+     117,    37,    66,   110,   111,   112,    38,    39,    40,    71,
+      41,    42,    43,    74,    44,   139,   140,   129,    45,    46,
+      96,    47,    48,    49,    50,   124,    89,    90,    51,    52
+};
+
+/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
+   STATE-NUM.  */
+#define YYPACT_NINF -60
+static const yytype_int8 yypact[] =
+{
+       4,    89,    89,    89,    89,    89,   -60,   -10,   -10,   -60,
+     -60,   -60,   -60,   -60,    80,   -60,     9,    -3,    68,     6,
+       7,    32,    34,    66,     5,    89,    89,    15,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,    93,   -60,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,
+     -60,   -60,    89,    77,   -60,   -60,    89,   -60,   -60,   -60,
+     -60,   -60,    66,    10,   -60,   -60,   -60,   -60,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,
+      31,   127,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,     4,   -60,   -60,
+     -60,   -60,   -60,    41,    81,   -60,    95,    89,    60,   -60,
+     -60,    66,   -60,   -60,    31,   -60,   -60,   -60,   127,   -60,
+     -60,    53,   124,    40,    77,    77,   -60,   -60,   -60,   -60,
+     127,   -60,    81,    98,   -60,   -60,   -60,   -60,   101,   101,
+     101,    55,    77,    77,   -60,    95,    95
+};
+
+/* YYPGOTO[NTERM-NUM].  */
+static const yytype_int8 yypgoto[] =
+{
+     -60,   -60,    -1,   -18,   -60,   -60,   -59,   -19,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,   105,   -56,   -27,
+     -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,    -4,    46,   -60,   -60,   -60,
+     -60,   -60,   -60,   -60,   -60,    14,   -60,   -60,   -60,   -60
+};
+
+/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
+   positive, shift that token.  If negative, reduce the rule which
+   number is the opposite.  If zero, do what YYDEFACT says.
+   If YYTABLE_NINF, syntax error.  */
+#define YYTABLE_NINF -68
+static const yytype_int16 yytable[] =
+{
+      57,    58,    59,    60,    61,   101,   103,   116,    99,   100,
+      63,   -67,   -67,    99,   100,   106,     1,     2,     3,     4,
+       5,     6,     7,     8,   104,   105,   107,     9,    10,    11,
+      12,    13,    14,    73,    99,   100,    15,    16,    97,    17,
+      18,   -44,    19,    72,    20,    91,    21,   120,    92,    22,
+      23,    24,   -44,   102,   119,   121,    53,    54,    55,    56,
+     -60,   113,   144,    93,   141,   118,    25,    26,   122,    99,
+     100,   -60,   123,   143,   131,    94,    95,   154,   145,   146,
+      53,    54,    55,    56,    53,    54,    55,    56,   130,   151,
+     152,   153,    53,    54,    55,    56,   155,   156,   114,    67,
+     108,   109,   131,   137,   134,   135,   123,   149,   150,    68,
+      69,    70,   141,    65,    75,   148,   136,    76,    77,    78,
+      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
+      99,   100,   125,   134,   135,   141,   147,   128,   138
+};
+
+static const yytype_uint8 yycheck[] =
+{
+       1,     2,     3,     4,     5,    23,    24,    63,     3,     4,
+      20,     7,     8,     3,     4,     0,    12,    13,    14,    15,
+      16,    17,    18,    19,    25,    26,    11,    23,    24,    25,
+      26,    27,    28,    36,     3,     4,    32,    33,     4,    35,
+      36,     0,    38,    34,    40,    39,    42,    37,    41,    45,
+      46,    47,    11,    48,    72,    73,     3,     4,     5,     6,
+       0,    62,    22,    31,    11,    66,    62,    63,    37,     3,
+       4,    11,    90,   132,    21,    43,    44,    22,   134,   135,
+       3,     4,     5,     6,     3,     4,     5,     6,   107,   148,
+     149,   150,     3,     4,     5,     6,   152,   153,    21,    19,
+       7,     8,    21,   121,     9,    10,   124,     9,    10,    29,
+      30,    31,    11,     8,    46,   142,   117,    49,    50,    51,
+      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
+       3,     4,     5,     9,    10,    11,   140,    91,   124
+};
+
+/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
+   symbol of state STATE-NUM.  */
+static const yytype_uint8 yystos[] =
+{
+       0,    12,    13,    14,    15,    16,    17,    18,    19,    23,
+      24,    25,    26,    27,    28,    32,    33,    35,    36,    38,
+      40,    42,    45,    46,    47,    62,    63,    65,    71,    72,
+      73,    74,    75,    76,    77,    79,    80,    85,    90,    91,
+      92,    94,    95,    96,    98,   102,   103,   105,   106,   107,
+     108,   112,   113,     3,     4,     5,     6,    66,    66,    66,
+      66,    66,    78,    20,    81,    81,    86,    19,    29,    30,
+      31,    93,    34,    36,    97,    46,    49,    50,    51,    52,
+      53,    54,    55,    56,    57,    58,    59,    60,    61,   110,
+     111,    39,    41,    31,    43,    44,   104,     4,    69,     3,
+       4,    67,    48,    67,    66,    66,     0,    11,     7,     8,
+      87,    88,    89,    66,    21,    66,    82,    84,    66,    67,
+      37,    67,    37,    67,   109,     5,    67,    68,   100,   101,
+      71,    21,    82,    83,     9,    10,    66,    67,   109,    99,
+     100,    11,    70,    70,    22,    82,    82,    99,    83,     9,
+      10,    70,    70,    70,    22,    82,    82
+};
+
+#define yyerrok		(yyerrstatus = 0)
+#define yyclearin	(yychar = YYEMPTY)
+#define YYEMPTY		(-2)
+#define YYEOF		0
+
+#define YYACCEPT	goto yyacceptlab
+#define YYABORT		goto yyabortlab
+#define YYERROR		goto yyerrorlab
+
+
+/* Like YYERROR except do call yyerror.  This remains here temporarily
+   to ease the transition to the new meaning of YYERROR, for GCC.
+   Once GCC version 2 has supplanted version 1, this can go.  */
+
+#define YYFAIL		goto yyerrlab
+
+#define YYRECOVERING()  (!!yyerrstatus)
+
+#define YYBACKUP(Token, Value)					\
+do								\
+  if (yychar == YYEMPTY && yylen == 1)				\
+    {								\
+      yychar = (Token);						\
+      yylval = (Value);						\
+      yytoken = YYTRANSLATE (yychar);				\
+      YYPOPSTACK (1);						\
+      goto yybackup;						\
+    }								\
+  else								\
+    {								\
+      yyerror (class, file, alloc_parent, lineno, YY_("syntax error: cannot back up")); \
+      YYERROR;							\
+    }								\
+while (YYID (0))
+
+
+#define YYTERROR	1
+#define YYERRCODE	256
+
+
+/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
+   If N is 0, then set CURRENT to the empty location which ends
+   the previous symbol: RHS[0] (always defined).  */
+
+#define YYRHSLOC(Rhs, K) ((Rhs)[K])
+#ifndef YYLLOC_DEFAULT
+# define YYLLOC_DEFAULT(Current, Rhs, N)				\
+    do									\
+      if (YYID (N))                                                    \
+	{								\
+	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
+	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
+	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
+	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
+	}								\
+      else								\
+	{								\
+	  (Current).first_line   = (Current).last_line   =		\
+	    YYRHSLOC (Rhs, 0).last_line;				\
+	  (Current).first_column = (Current).last_column =		\
+	    YYRHSLOC (Rhs, 0).last_column;				\
+	}								\
+    while (YYID (0))
+#endif
+
+
+/* YY_LOCATION_PRINT -- Print the location on the stream.
+   This macro was not mandated originally: define only if we know
+   we won't break user code: when these are the locations we know.  */
+
+#ifndef YY_LOCATION_PRINT
+# if YYLTYPE_IS_TRIVIAL
+#  define YY_LOCATION_PRINT(File, Loc)			\
+     fprintf (File, "%d.%d-%d.%d",			\
+	      (Loc).first_line, (Loc).first_column,	\
+	      (Loc).last_line,  (Loc).last_column)
+# else
+#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
+# endif
+#endif
+
+
+/* YYLEX -- calling `yylex' with the right arguments.  */
+
+#ifdef YYLEX_PARAM
+# define YYLEX yylex (&yylval, YYLEX_PARAM)
+#else
+# define YYLEX yylex (&yylval, file, alloc_parent, lineno)
+#endif
+
+/* Enable debugging if requested.  */
+#if YYDEBUG
+
+# ifndef YYFPRINTF
+#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
+#  define YYFPRINTF fprintf
+# endif
+
+# define YYDPRINTF(Args)			\
+do {						\
+  if (yydebug)					\
+    YYFPRINTF Args;				\
+} while (YYID (0))
+
+# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
+do {									  \
+  if (yydebug)								  \
+    {									  \
+      YYFPRINTF (stderr, "%s ", Title);					  \
+      yy_symbol_print (stderr,						  \
+		  Type, Value, class, file, alloc_parent, lineno); \
+      YYFPRINTF (stderr, "\n");						  \
+    }									  \
+} while (YYID (0))
+
+
+/*--------------------------------.
+| Print this symbol on YYOUTPUT.  |
+`--------------------------------*/
+
+/*ARGSUSED*/
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static void
+yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, JobClass    *class, const char **file, void        *alloc_parent, size_t      *lineno)
+#else
+static void
+yy_symbol_value_print (yyoutput, yytype, yyvaluep, class, file, alloc_parent, lineno)
+    FILE *yyoutput;
+    int yytype;
+    YYSTYPE const * const yyvaluep;
+    JobClass    *class;
+    const char **file;
+    void        *alloc_parent;
+    size_t      *lineno;
+#endif
+{
+  if (!yyvaluep)
+    return;
+  YYUSE (class);
+  YYUSE (file);
+  YYUSE (alloc_parent);
+  YYUSE (lineno);
+# ifdef YYPRINT
+  if (yytype < YYNTOKENS)
+    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
+# else
+  YYUSE (yyoutput);
+# endif
+  switch (yytype)
+    {
+      default:
+	break;
+    }
+}
+
+
+/*--------------------------------.
+| Print this symbol on YYOUTPUT.  |
+`--------------------------------*/
+
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static void
+yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, JobClass    *class, const char **file, void        *alloc_parent, size_t      *lineno)
+#else
+static void
+yy_symbol_print (yyoutput, yytype, yyvaluep, class, file, alloc_parent, lineno)
+    FILE *yyoutput;
+    int yytype;
+    YYSTYPE const * const yyvaluep;
+    JobClass    *class;
+    const char **file;
+    void        *alloc_parent;
+    size_t      *lineno;
+#endif
+{
+  if (yytype < YYNTOKENS)
+    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
+  else
+    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);
+
+  yy_symbol_value_print (yyoutput, yytype, yyvaluep, class, file, alloc_parent, lineno);
+  YYFPRINTF (yyoutput, ")");
+}
+
+/*------------------------------------------------------------------.
+| yy_stack_print -- Print the state stack from its BOTTOM up to its |
+| TOP (included).                                                   |
+`------------------------------------------------------------------*/
+
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static void
+yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
+#else
+static void
+yy_stack_print (bottom, top)
+    yytype_int16 *bottom;
+    yytype_int16 *top;
+#endif
+{
+  YYFPRINTF (stderr, "Stack now");
+  for (; bottom <= top; ++bottom)
+    YYFPRINTF (stderr, " %d", *bottom);
+  YYFPRINTF (stderr, "\n");
+}
+
+# define YY_STACK_PRINT(Bottom, Top)				\
+do {								\
+  if (yydebug)							\
+    yy_stack_print ((Bottom), (Top));				\
+} while (YYID (0))
+
+
+/*------------------------------------------------.
+| Report that the YYRULE is going to be reduced.  |
+`------------------------------------------------*/
+
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static void
+yy_reduce_print (YYSTYPE *yyvsp, int yyrule, JobClass    *class, const char **file, void        *alloc_parent, size_t      *lineno)
+#else
+static void
+yy_reduce_print (yyvsp, yyrule, class, file, alloc_parent, lineno)
+    YYSTYPE *yyvsp;
+    int yyrule;
+    JobClass    *class;
+    const char **file;
+    void        *alloc_parent;
+    size_t      *lineno;
+#endif
+{
+  int yynrhs = yyr2[yyrule];
+  int yyi;
+  unsigned long int yylno = yyrline[yyrule];
+  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
+	     yyrule - 1, yylno);
+  /* The symbols being reduced.  */
+  for (yyi = 0; yyi < yynrhs; yyi++)
+    {
+      fprintf (stderr, "   $%d = ", yyi + 1);
+      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
+		       &(yyvsp[(yyi + 1) - (yynrhs)])
+		       		       , class, file, alloc_parent, lineno);
+      fprintf (stderr, "\n");
+    }
+}
+
+# define YY_REDUCE_PRINT(Rule)		\
+do {					\
+  if (yydebug)				\
+    yy_reduce_print (yyvsp, Rule, class, file, alloc_parent, lineno); \
+} while (YYID (0))
+
+/* Nonzero means print parse trace.  It is left uninitialized so that
+   multiple parsers can coexist.  */
+int yydebug;
+#else /* !YYDEBUG */
+# define YYDPRINTF(Args)
+# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
+# define YY_STACK_PRINT(Bottom, Top)
+# define YY_REDUCE_PRINT(Rule)
+#endif /* !YYDEBUG */
+
+
+/* YYINITDEPTH -- initial size of the parser's stacks.  */
+#ifndef	YYINITDEPTH
+# define YYINITDEPTH 200
+#endif
+
+/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
+   if the built-in stack extension method is used).
+
+   Do not make this value too large; the results are undefined if
+   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
+   evaluated with infinite-precision integer arithmetic.  */
+
+#ifndef YYMAXDEPTH
+# define YYMAXDEPTH 10000
+#endif
+
+
+
+#if YYERROR_VERBOSE
+
+# ifndef yystrlen
+#  if defined __GLIBC__ && defined _STRING_H
+#   define yystrlen strlen
+#  else
+/* Return the length of YYSTR.  */
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static YYSIZE_T
+yystrlen (const char *yystr)
+#else
+static YYSIZE_T
+yystrlen (yystr)
+    const char *yystr;
+#endif
+{
+  YYSIZE_T yylen;
+  for (yylen = 0; yystr[yylen]; yylen++)
+    continue;
+  return yylen;
+}
+#  endif
+# endif
+
+# ifndef yystpcpy
+#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
+#   define yystpcpy stpcpy
+#  else
+/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
+   YYDEST.  */
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static char *
+yystpcpy (char *yydest, const char *yysrc)
+#else
+static char *
+yystpcpy (yydest, yysrc)
+    char *yydest;
+    const char *yysrc;
+#endif
+{
+  char *yyd = yydest;
+  const char *yys = yysrc;
+
+  while ((*yyd++ = *yys++) != '\0')
+    continue;
+
+  return yyd - 1;
+}
+#  endif
+# endif
+
+# ifndef yytnamerr
+/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
+   quotes and backslashes, so that it's suitable for yyerror.  The
+   heuristic is that double-quoting is unnecessary unless the string
+   contains an apostrophe, a comma, or backslash (other than
+   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
+   null, do not copy; instead, return the length of what the result
+   would have been.  */
+static YYSIZE_T
+yytnamerr (char *yyres, const char *yystr)
+{
+  if (*yystr == '"')
+    {
+      YYSIZE_T yyn = 0;
+      char const *yyp = yystr;
+
+      for (;;)
+	switch (*++yyp)
+	  {
+	  case '\'':
+	  case ',':
+	    goto do_not_strip_quotes;
+
+	  case '\\':
+	    if (*++yyp != '\\')
+	      goto do_not_strip_quotes;
+	    /* Fall through.  */
+	  default:
+	    if (yyres)
+	      yyres[yyn] = *yyp;
+	    yyn++;
+	    break;
+
+	  case '"':
+	    if (yyres)
+	      yyres[yyn] = '\0';
+	    return yyn;
+	  }
+    do_not_strip_quotes: ;
+    }
+
+  if (! yyres)
+    return yystrlen (yystr);
+
+  return yystpcpy (yyres, yystr) - yyres;
+}
+# endif
+
+/* Copy into YYRESULT an error message about the unexpected token
+   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
+   including the terminating null byte.  If YYRESULT is null, do not
+   copy anything; just return the number of bytes that would be
+   copied.  As a special case, return 0 if an ordinary "syntax error"
+   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
+   size calculation.  */
+static YYSIZE_T
+yysyntax_error (char *yyresult, int yystate, int yychar)
+{
+  int yyn = yypact[yystate];
+
+  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
+    return 0;
+  else
+    {
+      int yytype = YYTRANSLATE (yychar);
+      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
+      YYSIZE_T yysize = yysize0;
+      YYSIZE_T yysize1;
+      int yysize_overflow = 0;
+      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
+      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
+      int yyx;
+
+# if 0
+      /* This is so xgettext sees the translatable formats that are
+	 constructed on the fly.  */
+      YY_("syntax error, unexpected %s");
+      YY_("syntax error, unexpected %s, expecting %s");
+      YY_("syntax error, unexpected %s, expecting %s or %s");
+      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
+      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
+# endif
+      char *yyfmt;
+      char const *yyf;
+      static char const yyunexpected[] = "syntax error, unexpected %s";
+      static char const yyexpecting[] = ", expecting %s";
+      static char const yyor[] = " or %s";
+      char yyformat[sizeof yyunexpected
+		    + sizeof yyexpecting - 1
+		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
+		       * (sizeof yyor - 1))];
+      char const *yyprefix = yyexpecting;
+
+      /* Start YYX at -YYN if negative to avoid negative indexes in
+	 YYCHECK.  */
+      int yyxbegin = yyn < 0 ? -yyn : 0;
+
+      /* Stay within bounds of both yycheck and yytname.  */
+      int yychecklim = YYLAST - yyn + 1;
+      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
+      int yycount = 1;
+
+      yyarg[0] = yytname[yytype];
+      yyfmt = yystpcpy (yyformat, yyunexpected);
+
+      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
+	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
+	  {
+	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
+	      {
+		yycount = 1;
+		yysize = yysize0;
+		yyformat[sizeof yyunexpected - 1] = '\0';
+		break;
+	      }
+	    yyarg[yycount++] = yytname[yyx];
+	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
+	    yysize_overflow |= (yysize1 < yysize);
+	    yysize = yysize1;
+	    yyfmt = yystpcpy (yyfmt, yyprefix);
+	    yyprefix = yyor;
+	  }
+
+      yyf = YY_(yyformat);
+      yysize1 = yysize + yystrlen (yyf);
+      yysize_overflow |= (yysize1 < yysize);
+      yysize = yysize1;
+
+      if (yysize_overflow)
+	return YYSIZE_MAXIMUM;
+
+      if (yyresult)
+	{
+	  /* Avoid sprintf, as that infringes on the user's name space.
+	     Don't have undefined behavior even if the translation
+	     produced a string with the wrong number of "%s"s.  */
+	  char *yyp = yyresult;
+	  int yyi = 0;
+	  while ((*yyp = *yyf) != '\0')
+	    {
+	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
+		{
+		  yyp += yytnamerr (yyp, yyarg[yyi++]);
+		  yyf += 2;
+		}
+	      else
+		{
+		  yyp++;
+		  yyf++;
+		}
+	    }
+	}
+      return yysize;
+    }
+}
+#endif /* YYERROR_VERBOSE */
+
+
+/*-----------------------------------------------.
+| Release the memory associated to this symbol.  |
+`-----------------------------------------------*/
+
+/*ARGSUSED*/
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+static void
+yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, JobClass    *class, const char **file, void        *alloc_parent, size_t      *lineno)
+#else
+static void
+yydestruct (yymsg, yytype, yyvaluep, class, file, alloc_parent, lineno)
+    const char *yymsg;
+    int yytype;
+    YYSTYPE *yyvaluep;
+    JobClass    *class;
+    const char **file;
+    void        *alloc_parent;
+    size_t      *lineno;
+#endif
+{
+  YYUSE (yyvaluep);
+  YYUSE (class);
+  YYUSE (file);
+  YYUSE (alloc_parent);
+  YYUSE (lineno);
+
+  if (!yymsg)
+    yymsg = "Deleting";
+  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);
+
+  switch (yytype)
+    {
+
+      default:
+	break;
+    }
+}
+
+
+/* Prevent warnings from -Wmissing-prototypes.  */
+
+#ifdef YYPARSE_PARAM
+#if defined __STDC__ || defined __cplusplus
+int yyparse (void *YYPARSE_PARAM);
+#else
+int yyparse ();
+#endif
+#else /* ! YYPARSE_PARAM */
+#if defined __STDC__ || defined __cplusplus
+int yyparse (JobClass    *class, const char **file, void        *alloc_parent, size_t      *lineno);
+#else
+int yyparse ();
+#endif
+#endif /* ! YYPARSE_PARAM */
+
+
+
+
+
+
+/*----------.
+| yyparse.  |
+`----------*/
+
+#ifdef YYPARSE_PARAM
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+int
+yyparse (void *YYPARSE_PARAM)
+#else
+int
+yyparse (YYPARSE_PARAM)
+    void *YYPARSE_PARAM;
+#endif
+#else /* ! YYPARSE_PARAM */
+#if (defined __STDC__ || defined __C99__FUNC__ \
+     || defined __cplusplus || defined _MSC_VER)
+int
+yyparse (JobClass    *class, const char **file, void        *alloc_parent, size_t      *lineno)
+#else
+int
+yyparse (class, file, alloc_parent, lineno)
+    JobClass    *class;
+    const char **file;
+    void        *alloc_parent;
+    size_t      *lineno;
+#endif
+#endif
+{
+  /* The look-ahead symbol.  */
+int yychar;
+
+/* The semantic value of the look-ahead symbol.  */
+YYSTYPE yylval;
+
+/* Number of syntax errors so far.  */
+int yynerrs;
+
+  int yystate;
+  int yyn;
+  int yyresult;
+  /* Number of tokens to shift before error messages enabled.  */
+  int yyerrstatus;
+  /* Look-ahead token as an internal (translated) token number.  */
+  int yytoken = 0;
+#if YYERROR_VERBOSE
+  /* Buffer for error messages, and its allocated size.  */
+  char yymsgbuf[128];
+  char *yymsg = yymsgbuf;
+  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
+#endif
+
+  /* Three stacks and their tools:
+     `yyss': related to states,
+     `yyvs': related to semantic values,
+     `yyls': related to locations.
+
+     Refer to the stacks thru separate pointers, to allow yyoverflow
+     to reallocate them elsewhere.  */
+
+  /* The state stack.  */
+  yytype_int16 yyssa[YYINITDEPTH];
+  yytype_int16 *yyss = yyssa;
+  yytype_int16 *yyssp;
+
+  /* The semantic value stack.  */
+  YYSTYPE yyvsa[YYINITDEPTH];
+  YYSTYPE *yyvs = yyvsa;
+  YYSTYPE *yyvsp;
+
+
+
+#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))
+
+  YYSIZE_T yystacksize = YYINITDEPTH;
+
+  /* The variables used to return semantic value and location from the
+     action routines.  */
+  YYSTYPE yyval;
+
+
+  /* The number of symbols on the RHS of the reduced rule.
+     Keep to zero when no symbol should be popped.  */
+  int yylen = 0;
+
+  YYDPRINTF ((stderr, "Starting parse\n"));
+
+  yystate = 0;
+  yyerrstatus = 0;
+  yynerrs = 0;
+  yychar = YYEMPTY;		/* Cause a token to be read.  */
+
+  /* Initialize stack pointers.
+     Waste one element of value and location stack
+     so that they stay on the same level as the state stack.
+     The wasted elements are never initialized.  */
+
+  yyssp = yyss;
+  yyvsp = yyvs;
+
+  goto yysetstate;
+
+/*------------------------------------------------------------.
+| yynewstate -- Push a new state, which is found in yystate.  |
+`------------------------------------------------------------*/
+ yynewstate:
+  /* In all cases, when you get here, the value and location stacks
+     have just been pushed.  So pushing a state here evens the stacks.  */
+  yyssp++;
+
+ yysetstate:
+  *yyssp = yystate;
+
+  if (yyss + yystacksize - 1 <= yyssp)
+    {
+      /* Get the current used size of the three stacks, in elements.  */
+      YYSIZE_T yysize = yyssp - yyss + 1;
+
+#ifdef yyoverflow
+      {
+	/* Give user a chance to reallocate the stack.  Use copies of
+	   these so that the &'s don't force the real ones into
+	   memory.  */
+	YYSTYPE *yyvs1 = yyvs;
+	yytype_int16 *yyss1 = yyss;
+
+
+	/* Each stack pointer address is followed by the size of the
+	   data in use in that stack, in bytes.  This used to be a
+	   conditional around just the two extra args, but that might
+	   be undefined if yyoverflow is a macro.  */
+	yyoverflow (YY_("memory exhausted"),
+		    &yyss1, yysize * sizeof (*yyssp),
+		    &yyvs1, yysize * sizeof (*yyvsp),
+
+		    &yystacksize);
+
+	yyss = yyss1;
+	yyvs = yyvs1;
+      }
+#else /* no yyoverflow */
+# ifndef YYSTACK_RELOCATE
+      goto yyexhaustedlab;
+# else
+      /* Extend the stack our own way.  */
+      if (YYMAXDEPTH <= yystacksize)
+	goto yyexhaustedlab;
+      yystacksize *= 2;
+      if (YYMAXDEPTH < yystacksize)
+	yystacksize = YYMAXDEPTH;
+
+      {
+	yytype_int16 *yyss1 = yyss;
+	union yyalloc *yyptr =
+	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
+	if (! yyptr)
+	  goto yyexhaustedlab;
+	YYSTACK_RELOCATE (yyss);
+	YYSTACK_RELOCATE (yyvs);
+
+#  undef YYSTACK_RELOCATE
+	if (yyss1 != yyssa)
+	  YYSTACK_FREE (yyss1);
+      }
+# endif
+#endif /* no yyoverflow */
+
+      yyssp = yyss + yysize - 1;
+      yyvsp = yyvs + yysize - 1;
+
+
+      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
+		  (unsigned long int) yystacksize));
+
+      if (yyss + yystacksize - 1 <= yyssp)
+	YYABORT;
+    }
+
+  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
+
+  goto yybackup;
+
+/*-----------.
+| yybackup.  |
+`-----------*/
+yybackup:
+
+  /* Do appropriate processing given the current state.  Read a
+     look-ahead token if we need one and don't already have one.  */
+
+  /* First try to decide what to do without reference to look-ahead token.  */
+  yyn = yypact[yystate];
+  if (yyn == YYPACT_NINF)
+    goto yydefault;
+
+  /* Not known => get a look-ahead token if don't already have one.  */
+
+  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
+  if (yychar == YYEMPTY)
+    {
+      YYDPRINTF ((stderr, "Reading a token: "));
+      yychar = YYLEX;
+    }
+
+  if (yychar <= YYEOF)
+    {
+      yychar = yytoken = YYEOF;
+      YYDPRINTF ((stderr, "Now at end of input.\n"));
+    }
+  else
+    {
+      yytoken = YYTRANSLATE (yychar);
+      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
+    }
+
+  /* If the proper action on seeing token YYTOKEN is to reduce or to
+     detect an error, take that action.  */
+  yyn += yytoken;
+  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
+    goto yydefault;
+  yyn = yytable[yyn];
+  if (yyn <= 0)
+    {
+      if (yyn == 0 || yyn == YYTABLE_NINF)
+	goto yyerrlab;
+      yyn = -yyn;
+      goto yyreduce;
+    }
+
+  if (yyn == YYFINAL)
+    YYACCEPT;
+
+  /* Count tokens shifted since error; after three, turn off error
+     status.  */
+  if (yyerrstatus)
+    yyerrstatus--;
+
+  /* Shift the look-ahead token.  */
+  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
+
+  /* Discard the shifted token unless it is eof.  */
+  if (yychar != YYEOF)
+    yychar = YYEMPTY;
+
+  yystate = yyn;
+  *++yyvsp = yylval;
+
+  goto yynewstate;
+
+
+/*-----------------------------------------------------------.
+| yydefault -- do the default action for the current state.  |
+`-----------------------------------------------------------*/
+yydefault:
+  yyn = yydefact[yystate];
+  if (yyn == 0)
+    goto yyerrlab;
+  goto yyreduce;
+
+
+/*-----------------------------.
+| yyreduce -- Do a reduction.  |
+`-----------------------------*/
+yyreduce:
+  /* yyn is the number of a rule to reduce with.  */
+  yylen = yyr2[yyn];
+
+  /* If YYLEN is nonzero, implement the default value of the action:
+     `$$ = $1'.
+
+     Otherwise, the following line sets YYVAL to garbage.
+     This behavior is undocumented and Bison
+     users should not rely upon it.  Assigning to YYVAL
+     unconditionally makes the parser a bit smaller, and it avoids a
+     GCC warning that YYVAL may be used uninitialized.  */
+  yyval = yyvsp[1-yylen];
+
+
+  YY_REDUCE_PRINT (yyn);
+  switch (yyn)
+    {
+        case 6:
+#line 150 "parse_job.y"
+    { (yyval.string) = (yyvsp[(1) - (1)].string);        ;}
+    break;
+
+  case 7:
+#line 151 "parse_job.y"
+    { (yyval.string) = (yyvsp[(1) - (1)].multi).string; ;}
+    break;
+
+  case 8:
+#line 152 "parse_job.y"
+    { (yyval.string) = (yyvsp[(1) - (1)].multi).string; ;}
+    break;
+
+  case 9:
+#line 153 "parse_job.y"
+    { (yyval.string) = (yyvsp[(1) - (1)].multi).string; ;}
+    break;
+
+  case 10:
+#line 155 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].multi).num; ;}
+    break;
+
+  case 11:
+#line 156 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].multi).num; ;}
+    break;
+
+  case 12:
+#line 158 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].multi).num; ;}
+    break;
+
+  case 13:
+#line 159 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].multi).num; ;}
+    break;
+
+  case 39:
+#line 189 "parse_job.y"
+    { class->instance = YY_NIH_SYSERR (nih_strdup (class, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 40:
+#line 192 "parse_job.y"
+    { class->description = YY_NIH_SYSERR (nih_strdup (class, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 41:
+#line 195 "parse_job.y"
+    { class->author = YY_NIH_SYSERR (nih_strdup (class, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 42:
+#line 198 "parse_job.y"
+    { class->version = YY_NIH_SYSERR (nih_strdup (class, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 43:
+#line 201 "parse_job.y"
+    { YY_NIH_SYSERR (nih_str_array_add (&class->env, class, NULL, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 44:
+#line 204 "parse_job.y"
+    { YY_NIH_SYSERR (nih_str_array_add (&class->export, class, NULL, (yyvsp[(3) - (3)].string))); ;}
+    break;
+
+  case 46:
+#line 207 "parse_job.y"
+    { YY_NIH_SYSERR (nih_str_array_add (&class->export, class, NULL, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 47:
+#line 209 "parse_job.y"
+    { class->start_on = (yyvsp[(2) - (2)].oper); ;}
+    break;
+
+  case 48:
+#line 210 "parse_job.y"
+    { class->stop_on = (yyvsp[(2) - (2)].oper); ;}
+    break;
+
+  case 49:
+#line 211 "parse_job.y"
+    { (yyval.oper) = (yyvsp[(2) - (2)].oper); ;}
+    break;
+
+  case 50:
+#line 212 "parse_job.y"
+    { (yyval.oper) = (yyvsp[(1) - (1)].oper); ;}
+    break;
+
+  case 51:
+#line 213 "parse_job.y"
+    { (yyval.oper) = (yyvsp[(2) - (3)].oper); ;}
+    break;
+
+  case 52:
+#line 214 "parse_job.y"
+    {
+		  	(yyval.oper) = YY_NIH_SYSERR (event_operator_new (class, EVENT_OR,
+							        NULL, NULL));
+			nih_ref ((yyvsp[(1) - (3)].oper), (yyval.oper));
+			nih_ref ((yyvsp[(3) - (3)].oper), (yyval.oper));
+			nih_unref ((yyvsp[(1) - (3)].oper), class);
+			nih_unref ((yyvsp[(3) - (3)].oper), class);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(1) - (3)].oper)->node, NIH_TREE_LEFT);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(3) - (3)].oper)->node, NIH_TREE_RIGHT);
+	      ;}
+    break;
+
+  case 53:
+#line 224 "parse_job.y"
+    {
+		  	(yyval.oper) = YY_NIH_SYSERR (event_operator_new (class, EVENT_AND,
+							        NULL, NULL));
+			nih_ref ((yyvsp[(1) - (3)].oper), (yyval.oper));
+			nih_ref ((yyvsp[(3) - (3)].oper), (yyval.oper));
+			nih_unref ((yyvsp[(1) - (3)].oper), class);
+			nih_unref ((yyvsp[(3) - (3)].oper), class);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(1) - (3)].oper)->node, NIH_TREE_LEFT);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(3) - (3)].oper)->node, NIH_TREE_RIGHT);
+	      ;}
+    break;
+
+  case 54:
+#line 234 "parse_job.y"
+    { (yyval.oper) = (yyvsp[(1) - (1)].oper); ;}
+    break;
+
+  case 55:
+#line 235 "parse_job.y"
+    { (yyval.oper) = (yyvsp[(3) - (5)].oper); ;}
+    break;
+
+  case 56:
+#line 236 "parse_job.y"
+    {
+		  	(yyval.oper) = YY_NIH_SYSERR (event_operator_new (class, EVENT_OR,
+							        NULL, NULL));
+			nih_ref ((yyvsp[(1) - (5)].oper), (yyval.oper));
+			nih_ref ((yyvsp[(5) - (5)].oper), (yyval.oper));
+			nih_unref ((yyvsp[(1) - (5)].oper), class);
+			nih_unref ((yyvsp[(5) - (5)].oper), class);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(1) - (5)].oper)->node, NIH_TREE_LEFT);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(5) - (5)].oper)->node, NIH_TREE_RIGHT);
+	             ;}
+    break;
+
+  case 57:
+#line 246 "parse_job.y"
+    {
+		  	(yyval.oper) = YY_NIH_SYSERR (event_operator_new (class, EVENT_AND,
+							        NULL, NULL));
+			nih_ref ((yyvsp[(1) - (5)].oper), (yyval.oper));
+			nih_ref ((yyvsp[(5) - (5)].oper), (yyval.oper));
+			nih_unref ((yyvsp[(1) - (5)].oper), class);
+			nih_unref ((yyvsp[(5) - (5)].oper), class);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(1) - (5)].oper)->node, NIH_TREE_LEFT);
+			nih_tree_add (&(yyval.oper)->node, &(yyvsp[(5) - (5)].oper)->node, NIH_TREE_RIGHT);
+	             ;}
+    break;
+
+  case 58:
+#line 256 "parse_job.y"
+    { (yyval.oper) = YY_NIH_SYSERR (event_operator_new (class, EVENT_MATCH, (yyvsp[(1) - (1)].string), NULL)); ;}
+    break;
+
+  case 59:
+#line 257 "parse_job.y"
+    {
+		  (yyval.oper) = (yyvsp[(1) - (2)].oper);
+		  YY_NIH_SYSERR (nih_str_array_add (&(yyval.oper)->env, class,
+						    NULL, (yyvsp[(2) - (2)].string)));
+	  ;}
+    break;
+
+  case 60:
+#line 264 "parse_job.y"
+    { YY_NIH_SYSERR (nih_str_array_add (&class->emits, class, NULL, (yyvsp[(3) - (3)].string))); ;}
+    break;
+
+  case 62:
+#line 267 "parse_job.y"
+    { YY_NIH_SYSERR (nih_str_array_add (&class->emits, class, NULL, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 63:
+#line 269 "parse_job.y"
+    {
+		(yyval.proc) = YY_NIH_SYSERR (process_new (class->process));
+		(yyval.proc)->script = FALSE;
+		(yyval.proc)->command = YY_NIH_SYSERR (nih_strdup ((yyval.proc), (yyvsp[(1) - (1)].string)));
+	;}
+    break;
+
+  case 64:
+#line 274 "parse_job.y"
+    {
+		(yyval.proc) = YY_NIH_SYSERR (process_new (class->process));
+		(yyval.proc)->script = TRUE;
+		(yyval.proc)->command = YY_NIH_SYSERR (nih_strdup ((yyval.proc), (yyvsp[(1) - (1)].string)));
+	;}
+    break;
+
+  case 65:
+#line 279 "parse_job.y"
+    { (yyval.proc) = (yyvsp[(1) - (1)].proc); ;}
+    break;
+
+  case 66:
+#line 280 "parse_job.y"
+    { (yyval.proc) = (yyvsp[(1) - (1)].proc); ;}
+    break;
+
+  case 67:
+#line 281 "parse_job.y"
+    { (yyval.num) = PROCESS_MAIN;       ;}
+    break;
+
+  case 68:
+#line 282 "parse_job.y"
+    { (yyval.num) = PROCESS_PRE_START;  ;}
+    break;
+
+  case 69:
+#line 283 "parse_job.y"
+    { (yyval.num) = PROCESS_PRE_STOP;   ;}
+    break;
+
+  case 70:
+#line 284 "parse_job.y"
+    { (yyval.num) = PROCESS_POST_START; ;}
+    break;
+
+  case 71:
+#line 285 "parse_job.y"
+    { (yyval.num) = PROCESS_POST_STOP;  ;}
+    break;
+
+  case 72:
+#line 286 "parse_job.y"
+    {
+		if (class->process[(yyvsp[(1) - (2)].num)])
+			nih_unref (class->process[(yyvsp[(1) - (2)].num)],
+				   class->process);
+		class->process[(yyvsp[(1) - (2)].num)] = (yyvsp[(2) - (2)].proc);
+	;}
+    break;
+
+  case 74:
+#line 294 "parse_job.y"
+    { class->expect = EXPECT_STOP;   ;}
+    break;
+
+  case 75:
+#line 295 "parse_job.y"
+    { class->expect = EXPECT_DAEMON; ;}
+    break;
+
+  case 76:
+#line 296 "parse_job.y"
+    { class->expect = EXPECT_FORK;   ;}
+    break;
+
+  case 77:
+#line 297 "parse_job.y"
+    { class->expect = EXPECT_NONE;   ;}
+    break;
+
+  case 78:
+#line 299 "parse_job.y"
+    { class->task = TRUE; ;}
+    break;
+
+  case 79:
+#line 302 "parse_job.y"
+    {
+		class->kill_timeout = (yyvsp[(3) - (3)].num);
+		if (class->kill_timeout < 0) {
+			nih_error_raise (NIH_CONFIG_UNEXPECTED_TOKEN,
+					 _(NIH_CONFIG_UNEXPECTED_TOKEN_STR));
+			YYABORT;
+		}
+	;}
+    break;
+
+  case 81:
+#line 312 "parse_job.y"
+    { class->respawn = TRUE; ;}
+    break;
+
+  case 82:
+#line 313 "parse_job.y"
+    {
+		 	class->respawn_limit = 0;
+		 	class->respawn_interval = 0;
+	    ;}
+    break;
+
+  case 83:
+#line 317 "parse_job.y"
+    {
+			class->respawn_limit = (yyvsp[(2) - (3)].num);
+			class->respawn_interval = (yyvsp[(3) - (3)].num);
+			if (class->kill_timeout < 0 || class->respawn_interval < 0) {
+				nih_error_raise (NIH_CONFIG_UNEXPECTED_TOKEN,
+						 _(NIH_CONFIG_UNEXPECTED_TOKEN_STR));
+				YYABORT;
+			}
+	    ;}
+    break;
+
+  case 87:
+#line 330 "parse_job.y"
+    {
+		int *new_ne;
+		new_ne = YY_NIH_SYSERR (nih_realloc (class->normalexit, class,
+				                     sizeof (int) *
+						     (class->normalexit_len
+						     + 1)));
+		class->normalexit = new_ne;
+		class->normalexit[class->normalexit_len++] = (yyvsp[(1) - (1)].num);
+	;}
+    break;
+
+  case 88:
+#line 339 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].num);      ;}
+    break;
+
+  case 89:
+#line 340 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].num) << 8; ;}
+    break;
+
+  case 90:
+#line 342 "parse_job.y"
+    { class->leader = TRUE; ;}
+    break;
+
+  case 92:
+#line 345 "parse_job.y"
+    { class->console = CONSOLE_NONE;   ;}
+    break;
+
+  case 93:
+#line 346 "parse_job.y"
+    { class->console = CONSOLE_OUTPUT; ;}
+    break;
+
+  case 94:
+#line 347 "parse_job.y"
+    { class->console = CONSOLE_OWNER;  ;}
+    break;
+
+  case 95:
+#line 349 "parse_job.y"
+    { class->umask = (yyvsp[(2) - (2)].num); ;}
+    break;
+
+  case 96:
+#line 351 "parse_job.y"
+    { class->nice = (yyvsp[(2) - (2)].num); ;}
+    break;
+
+  case 97:
+#line 353 "parse_job.y"
+    { class->oom_adj = (yyvsp[(2) - (2)].num);  ;}
+    break;
+
+  case 98:
+#line 354 "parse_job.y"
+    { class->oom_adj = -17; ;}
+    break;
+
+  case 100:
+#line 357 "parse_job.y"
+    { (yyval.num) = (yyvsp[(1) - (1)].num);            ;}
+    break;
+
+  case 101:
+#line 358 "parse_job.y"
+    { (yyval.num) = RLIM_INFINITY; ;}
+    break;
+
+  case 102:
+#line 360 "parse_job.y"
+    {
+		class->limits[(yyvsp[(1) - (3)].num)]->rlim_cur = (yyvsp[(2) - (3)].num);
+		class->limits[(yyvsp[(1) - (3)].num)]->rlim_max = (yyvsp[(3) - (3)].num);
+	    ;}
+    break;
+
+  case 103:
+#line 364 "parse_job.y"
+    { (yyval.num) = RLIMIT_AS;         ;}
+    break;
+
+  case 104:
+#line 365 "parse_job.y"
+    { (yyval.num) = RLIMIT_CORE;       ;}
+    break;
+
+  case 105:
+#line 366 "parse_job.y"
+    { (yyval.num) = RLIMIT_CPU;        ;}
+    break;
+
+  case 106:
+#line 367 "parse_job.y"
+    { (yyval.num) = RLIMIT_DATA;       ;}
+    break;
+
+  case 107:
+#line 368 "parse_job.y"
+    { (yyval.num) = RLIMIT_FSIZE;      ;}
+    break;
+
+  case 108:
+#line 369 "parse_job.y"
+    { (yyval.num) = RLIMIT_MEMLOCK;    ;}
+    break;
+
+  case 109:
+#line 370 "parse_job.y"
+    { (yyval.num) = RLIMIT_MSGQUEUE;   ;}
+    break;
+
+  case 110:
+#line 371 "parse_job.y"
+    { (yyval.num) = RLIMIT_NICE;       ;}
+    break;
+
+  case 111:
+#line 372 "parse_job.y"
+    { (yyval.num) = RLIMIT_NOFILE;     ;}
+    break;
+
+  case 112:
+#line 373 "parse_job.y"
+    { (yyval.num) = RLIMIT_NPROC;      ;}
+    break;
+
+  case 113:
+#line 374 "parse_job.y"
+    { (yyval.num) = RLIMIT_RSS;        ;}
+    break;
+
+  case 114:
+#line 375 "parse_job.y"
+    { (yyval.num) = RLIMIT_RTPRIO;     ;}
+    break;
+
+  case 115:
+#line 376 "parse_job.y"
+    { (yyval.num) = RLIMIT_SIGPENDING; ;}
+    break;
+
+  case 116:
+#line 377 "parse_job.y"
+    { (yyval.num) = RLIMIT_STACK;      ;}
+    break;
+
+  case 117:
+#line 380 "parse_job.y"
+    { class->chroot = YY_NIH_SYSERR (nih_strdup (class, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+  case 118:
+#line 383 "parse_job.y"
+    { class->chdir = YY_NIH_SYSERR (nih_strdup (class, (yyvsp[(2) - (2)].string))); ;}
+    break;
+
+
+/* Line 1267 of yacc.c.  */
+#line 2070 "parse_job.c"
+      default: break;
+    }
+  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);
+
+  YYPOPSTACK (yylen);
+  yylen = 0;
+  YY_STACK_PRINT (yyss, yyssp);
+
+  *++yyvsp = yyval;
+
+
+  /* Now `shift' the result of the reduction.  Determine what state
+     that goes to, based on the state we popped back to and the rule
+     number reduced by.  */
+
+  yyn = yyr1[yyn];
+
+  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
+  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
+    yystate = yytable[yystate];
+  else
+    yystate = yydefgoto[yyn - YYNTOKENS];
+
+  goto yynewstate;
+
+
+/*------------------------------------.
+| yyerrlab -- here on detecting error |
+`------------------------------------*/
+yyerrlab:
+  /* If not already recovering from an error, report this error.  */
+  if (!yyerrstatus)
+    {
+      ++yynerrs;
+#if ! YYERROR_VERBOSE
+      yyerror (class, file, alloc_parent, lineno, YY_("syntax error"));
+#else
+      {
+	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
+	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
+	  {
+	    YYSIZE_T yyalloc = 2 * yysize;
+	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
+	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
+	    if (yymsg != yymsgbuf)
+	      YYSTACK_FREE (yymsg);
+	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
+	    if (yymsg)
+	      yymsg_alloc = yyalloc;
+	    else
+	      {
+		yymsg = yymsgbuf;
+		yymsg_alloc = sizeof yymsgbuf;
+	      }
+	  }
+
+	if (0 < yysize && yysize <= yymsg_alloc)
+	  {
+	    (void) yysyntax_error (yymsg, yystate, yychar);
+	    yyerror (class, file, alloc_parent, lineno, yymsg);
+	  }
+	else
+	  {
+	    yyerror (class, file, alloc_parent, lineno, YY_("syntax error"));
+	    if (yysize != 0)
+	      goto yyexhaustedlab;
+	  }
+      }
+#endif
+    }
+
+
+
+  if (yyerrstatus == 3)
+    {
+      /* If just tried and failed to reuse look-ahead token after an
+	 error, discard it.  */
+
+      if (yychar <= YYEOF)
+	{
+	  /* Return failure if at end of input.  */
+	  if (yychar == YYEOF)
+	    YYABORT;
+	}
+      else
+	{
+	  yydestruct ("Error: discarding",
+		      yytoken, &yylval, class, file, alloc_parent, lineno);
+	  yychar = YYEMPTY;
+	}
+    }
+
+  /* Else will try to reuse look-ahead token after shifting the error
+     token.  */
+  goto yyerrlab1;
+
+
+/*---------------------------------------------------.
+| yyerrorlab -- error raised explicitly by YYERROR.  |
+`---------------------------------------------------*/
+yyerrorlab:
+
+  /* Pacify compilers like GCC when the user code never invokes
+     YYERROR and the label yyerrorlab therefore never appears in user
+     code.  */
+  if (/*CONSTCOND*/ 0)
+     goto yyerrorlab;
+
+  /* Do not reclaim the symbols of the rule which action triggered
+     this YYERROR.  */
+  YYPOPSTACK (yylen);
+  yylen = 0;
+  YY_STACK_PRINT (yyss, yyssp);
+  yystate = *yyssp;
+  goto yyerrlab1;
+
+
+/*-------------------------------------------------------------.
+| yyerrlab1 -- common code for both syntax error and YYERROR.  |
+`-------------------------------------------------------------*/
+yyerrlab1:
+  yyerrstatus = 3;	/* Each real token shifted decrements this.  */
+
+  for (;;)
+    {
+      yyn = yypact[yystate];
+      if (yyn != YYPACT_NINF)
+	{
+	  yyn += YYTERROR;
+	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
+	    {
+	      yyn = yytable[yyn];
+	      if (0 < yyn)
+		break;
+	    }
+	}
+
+      /* Pop the current state because it cannot handle the error token.  */
+      if (yyssp == yyss)
+	YYABORT;
+
+
+      yydestruct ("Error: popping",
+		  yystos[yystate], yyvsp, class, file, alloc_parent, lineno);
+      YYPOPSTACK (1);
+      yystate = *yyssp;
+      YY_STACK_PRINT (yyss, yyssp);
+    }
+
+  if (yyn == YYFINAL)
+    YYACCEPT;
+
+  *++yyvsp = yylval;
+
+
+  /* Shift the error token.  */
+  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);
+
+  yystate = yyn;
+  goto yynewstate;
+
+
+/*-------------------------------------.
+| yyacceptlab -- YYACCEPT comes here.  |
+`-------------------------------------*/
+yyacceptlab:
+  yyresult = 0;
+  goto yyreturn;
+
+/*-----------------------------------.
+| yyabortlab -- YYABORT comes here.  |
+`-----------------------------------*/
+yyabortlab:
+  yyresult = 1;
+  goto yyreturn;
+
+#ifndef yyoverflow
+/*-------------------------------------------------.
+| yyexhaustedlab -- memory exhaustion comes here.  |
+`-------------------------------------------------*/
+yyexhaustedlab:
+  yyerror (class, file, alloc_parent, lineno, YY_("memory exhausted"));
+  yyresult = 2;
+  /* Fall through.  */
+#endif
+
+yyreturn:
+  if (yychar != YYEOF && yychar != YYEMPTY)
+     yydestruct ("Cleanup: discarding lookahead",
+		 yytoken, &yylval, class, file, alloc_parent, lineno);
+  /* Do not reclaim the symbols of the rule which action triggered
+     this YYABORT or YYACCEPT.  */
+  YYPOPSTACK (yylen);
+  YY_STACK_PRINT (yyss, yyssp);
+  while (yyssp != yyss)
+    {
+      yydestruct ("Cleanup: popping",
+		  yystos[*yyssp], yyvsp, class, file, alloc_parent, lineno);
+      YYPOPSTACK (1);
+    }
+#ifndef yyoverflow
+  if (yyss != yyssa)
+    YYSTACK_FREE (yyss);
+#endif
+#if YYERROR_VERBOSE
+  if (yymsg != yymsgbuf)
+    YYSTACK_FREE (yymsg);
+#endif
+  /* Make sure YYID is used.  */
+  return YYID (yyresult);
+}
+
+
+#line 384 "parse_job.y"
+
+
+/**
+ * yyerror:
+ * @class: Job class we are reading in,
+ * @file: File we are reading,
+ * @parent: Allocation parent of temporary info.
+ * @lineno: Current line number
+ * @msg: Error message from Bison.
+ *
+ * Standard error reporting function for Bison. Called when we screw up.
+ **/
+static void
+yyerror (JobClass *class,  const char **file, void *parent,
+         size_t   *lineno, const char  *msg)
+{
+	if (nih_have_error ())
+		return;
+	if (**file)
+		nih_error_raise (NIH_CONFIG_UNEXPECTED_TOKEN,
+				 _(NIH_CONFIG_UNEXPECTED_TOKEN_STR));
+	else
+		nih_error_raise (NIH_CONFIG_EXPECTED_TOKEN,
+				 _(NIH_CONFIG_EXPECTED_TOKEN_STR));
+}
+
+/**
+ * yylex:
+ * @lvalp: Bison stack top.
+ * @file: The text of the file we are parsing.
+ * @alloc_parent: Parent for any allocated data.
+ * @lineno: Current line number.
+ *
+ * Standard bison lexer function. Breaks a config file into tokens.
+ */
+static int
+yylex (YYSTYPE *lvalp, const char **file, void *alloc_parent,
+       size_t  *lineno)
+{
+	int newlines = 0;
+	int in_comment = 0;
+	char *tok;
+
+	for (;**file && (isspace (**file) || in_comment); (*file)++) {
+		if (**file == '\n') {
+			newlines++;
+			in_comment = 0;
+		} else if (**file == '#') {
+			in_comment = 1;
+		}
+	}
+
+
+	*lineno += newlines;
+	if (newlines)
+		return '\n';
+
+	if (! **file)
+		return 0;
+
+	if (strchr ("()", **file))
+		return *((*file)++);
+
+	return categorize_token (lvalp, file,
+				 pull_token (file, alloc_parent, lineno),
+				 lineno);
+}
+
+/**
+ * pull_token:
+ * @file: The file to pull the token from (as a string).
+ * @alloc_parent: Parent for any allocated data.
+ * @lineno: Current line number, will be updated.
+ *
+ * Read and return the first token at *file, which does not begin with
+ * whitespace or end immediately.
+ */
+static char *
+pull_token (const char **file, void *alloc_parent, size_t *lineno)
+{
+	char *tok;
+	char *pos;
+	const char *end;
+	int quoted  = 0;
+	int escaped = 0;
+	size_t len = 0;
+	int had_newline = 0;
+	int maybe_keyword = 1;
+
+	for (end = *file; *end; end++) {
+		*lineno += had_newline;
+		had_newline = (*end == '\n') ? 1 : 0;
+		if (escaped) {
+			escaped = 0;
+			len++;
+		} else if (*end == '\\') {
+			escaped = 1;
+			maybe_keyword = 0;
+			continue;
+		} else if (*end == '"') {
+			quoted = !quoted;
+			maybe_keyword = 0;
+			continue;
+		} else if (!quoted && (isspace (*end) || strchr ("()", *end))) {
+			break;
+		} else {
+			len++;
+		}
+	}
+
+	if (quoted)
+		nih_error_raise (NIH_CONFIG_UNTERMINATED_QUOTE,
+				 _(NIH_CONFIG_UNTERMINATED_QUOTE_STR));
+
+	if (escaped)
+		nih_error_raise (NIH_CONFIG_TRAILING_SLASH,
+				 _(NIH_CONFIG_TRAILING_SLASH_STR));
+
+	tok = nih_alloc (alloc_parent, len + 1);
+	if (! tok)
+		nih_return_system_error (NULL);
+
+	for (pos = tok; *file != end; (*file)++) {
+		if (**file == '"')
+			continue;
+		if (**file == '\\')
+			(*file)++;
+		*(pos++) = **file;
+	}
+
+	*pos = '\0';
+	
+	return tok;
+}
+
+/**
+ * categorize_token:
+ * @lvalp: Stack top.
+ * @file: The file being parsed.
+ * @tok: Token to categorize.
+ *
+ * Categorize and stack-return the token @tok
+ */
+static int
+categorize_token (YYSTYPE *lvalp, const char **file, char *tok, size_t *lineno)
+{
+	char *loc;
+
+	if (! tok)
+		return 256;
+
+	lvalp->multi.num = strtoul (tok, &loc, 10);
+	lvalp->multi.string = tok;
+
+	if (*loc)
+		return categorize_string_token (lvalp, file, tok, lineno);
+
+	if (*tok == '0' && loc == tok + 4) {
+		lvalp->multi.num = strtoul (tok, NULL, 8);
+		return MAYBE_UMASK;
+	}
+
+	return MAYBE_NUMBER;
+}
+
+/**
+ * categorize_string_token:
+ * @lvalp: stack top.
+ * @file: The file being parsed.
+ * @tok: Token to categorize.
+ *
+ * Categorize and stack-return the token @tok, which is known not to be a
+ * numerical value.
+ */
+static int
+categorize_string_token (YYSTYPE *lvalp, const char **file, char *tok, size_t *lineno)
+{
+	int signum = nih_signal_from_name (tok);
+	if (signum >= 0) {
+		lvalp->multi.num = signum;
+		return MAYBE_SIGNAL;
+	}
+
+	if (! strcmp ("exec", tok)) {
+		const char *start = *file;
+		char *new;
+		while (isblank (*start))
+			start++;
+		while (**file && **file != '\n')
+			(*file)++;
+		if (*file == start)
+			return 256;
+		new = nih_alloc (tok, 1 + (*file - start));
+		if (! new)
+			nih_return_system_error (256);
+
+		memcpy (new, start, *file - start);
+		new[*file - start] = '\0';
+		lvalp->string = new;
+		return EXEC_LINE;
+	}
+
+	if (! strcmp ("script", tok)) {
+		const char *start = *file;
+		const char *end;
+		const char *pos;
+		char *new;
+
+		while (isspace (*start))
+			start++;
+
+		for (; **file; (*file)++) {
+			*lineno += (**file == '\n') ? 1 : 0;
+			if (strncmp ("\nend", *file, 4))
+				continue;
+			pos = *file + 4;
+			if (! isblank (*pos))
+				continue;
+			while (isblank (*pos))
+				pos++;
+			if (strncmp ("script", pos, 6))
+				continue;
+			pos += 6;
+			if ((! *pos) || isspace (*pos)) {
+				end = (*file) + 1;
+				*file = pos;
+				break;
+			}
+		}
+
+		if (!**file) {
+			nih_error_raise (NIH_CONFIG_UNTERMINATED_BLOCK,
+					 _(NIH_CONFIG_UNTERMINATED_BLOCK_STR));
+			return 256;
+		}
+		
+		new = nih_alloc (tok, 1 + (end - start));
+		if (! new)
+			nih_return_system_error (256);
+
+		memcpy (new, start, end - start);
+		new[end - start] = '\0';
+		lvalp->string = new;
+		return SCRIPT_BODY;
+	}
+
+	lvalp->string = tok;
+	return tok_lookup (tok);
+}
+
+/**
+ * tok_lookup:
+ * @tok: token to look up.
+ * 
+ * Figure out if a token is a string or keyword and return its type.
+ **/
+static int
+tok_lookup (char *tok)
+{
+	int i;
+	const char *sym;
+
+	for (i = 0; i < YYNTOKENS; i++) {
+		if (! yytname[i])
+			continue;
+		sym = yytname[i];
+
+		if (! *sym == '"')
+			continue;
+		sym++;
+
+		if (strncmp (sym, tok, strlen (tok)))
+			continue;
+		sym += strlen (tok);
+
+		if (! strcmp (sym, "\"")) {
+			return yytoknum[i];
+		}
+	}
+
+	return KNOWN_STRING;
+}
 
 /**
  * parse_job:
